package org.ow2.jonas.cxf.mdb.test.impl;

import javax.naming.InitialContext;
import javax.naming.NamingException;

import org.ow2.jonas.cxf.transport.mdb.api.AsyncHandler;
import org.ow2.jonas.cxf.transport.mdb.api.ContextInfo;



public class TestAsyncHandler implements AsyncHandler {

    private Checker checker = null;
    
    
    public TestAsyncHandler() throws NamingException {
        // lookup singleton bean
        this.checker = (Checker) new InitialContext().lookup("CheckerBean");
    }
    
    
    public void doHandlerFault(Throwable exception, ContextInfo contextInfo) {
        checker.handleFault(contextInfo, exception);        
    }

    public void doHandlerResponse(Object response, ContextInfo contextInfo) {
        checker.handleResponse(contextInfo, response);        
    }

    public boolean doYouKnowThisContext(ContextInfo contextInfo) {
        if (checker.isKnownContext(contextInfo)) {
            return true;
        }
        // invalid answer !
        checker.replyWithoutCall(contextInfo);
        return false;
    }

    public void saveContext(ContextInfo contextInfo) {
        // This web service has been called
        checker.addCall(contextInfo);
    }

}
